---
title: RTCPeerConnection.getConfiguration()
slug: Web/API/RTCPeerConnection/getConfiguration
tags:
  - API
  - Experimental
  - Interface
  - Method
  - RTCConfiguration
  - Reference
  - WebRTC
  - getConfiguration
---
<p>{{APIRef("WebRTC")}}{{SeeCompatTable}}</p>

<p>The <strong><code>RTCPeerConnection.getConfiguration()</code></strong> method returns an {{domxref("RTCConfiguration")}} object which indicates the current configuration of the {{domxref("RTCPeerConnection")}} on which the method is called.</p>

<p>The returned configuration is the last configuration applied via {{domxref("RTCPeerConnection.setConfiguration","setConfiguration()")}}, or if <code>setConfiguration()</code> hasn't been called, the configuration the <code>RTCPeerConnection</code> was constructed with. The configuration includes a list of the ICE servers used by the connection, information about transport policies, and identity information.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>configuration</em> = <em>RTCPeerConnection</em>.getConfiguration();</pre>

<h3 class="syntaxbox" id="Parameters">Parameters</h3>

<p>This method takes no input parameters.</p>

<h3 id="Return_value">Return value</h3>

<p>An {{domxref("RTCConfiguration")}} object describing the {{domxref("RTCPeerConnection")}}'s current configuration.</p>

<h2 id="Example">Example</h2>

<p>This example adds a new certificate to an active connection if it doesn't already have one in use.</p>

<pre class="brush: js">let configuration = myPeerConnection.getConfiguration();

if ((configuration.certificates != undefined) &amp;&amp; (!configuration.certificates.length)) {
   RTCPeerConnection.generateCertificate({
      name: 'RSASSA-PKCS1-v1_5',
      hash: 'SHA-256',
      modulusLength: 2048,
      publicExponent: new Uint8Array([1, 0, 1])
  }).then(function(cert) {
    configuration.certificates = [cert];
    myPeerConnection.setConfiguration(configuration);
  });
}
</pre>

<p>This example fetches the current configuration of the {{domxref("RTCPeerConnection")}}, then looks to see if it has any certificates set by examining whether or not (a) the configuration has a value for <code>certificates</code>, and (b) whether its length is zero.</p>

<p>If it's determined that there are no certificates in place, {{domxref("RTCPeerConnection.generateCertificate()")}} is called to create a new certificate; we provide a fulfillment handler which adds a new array containing the one newly-created certificate to the current configuration and passes it to {{domxref("RTCPeerConnect.setConfiguration", "setConfiguration()")}} to add the certificate to the connection.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#dom-rtcpeerconnection-getconfiguration', 'getConfiguration()')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCPeerConnection.getConfiguration")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("RTCPeerConnection.setConfiguration()")}}</li>
 <li>{{domxref("RTCConfiguration")}}</li>
 <li>{{domxref("RTCPeerConnection")}}</li>
</ul>
